* para criar novos jogos, por digitacao ou poor importacao de arquivo txt
func cria()

loca tecasc  := 0   // ascii da ultima tecla
loca teccar  := ''  // chr da ultima tecla
loca vtmp    := ''  // valores devolvidos pela volta()
loca valret  := .f.                     // retorno de cria()

loca i  := 0
loca c  := 0
loca l  := 0
loca cg := 0
loca numerant := 0

loca xcas := ''     // guarda caracter apagado para recoloca-lo nas casas adjacentes
loca xlin := 0      // linha do tabuleiro em que o caracter foi apagado
loca xcol := 0      // coluna do tabuleiro em que o caracter foi apagado
loca xgru := 0      // grupo no tabuleiro em que o caracter foi apagado
loca xcgr := 0      // casa do tabuleiro em que o caracter foi apagado
loca tmp  := 0      // auxiliar para redistribuicao de caracteres apagados

loca mexeu := .f.   // para salvar - ou nao - o jogo na saida

loca molt     := .t.                    // moldura do tabuleiro
loca grid     := .t.                    // grid do tabuleiro
loca moln     := .t.                    // molduta das notas
loca pnl      := .t.                    // painel
loca mosdat   := .t.                    // flag - (re)carrega e (re)mostra os dados
loca fazcarga := .t.                    // carrega ram dados dos dbfs

loca elin := 0      // para a posio do mouse em mrow()
loca ecol := 0      // para a posio do mouse em mcol()

sele rollback
zap
dbcommitall()

// do sudoku1
sele sudoku1
dbgobottom()
xnumero  = jogo1+1
xcriacao = date()

// do sudoku2
xultmov = ctod('//')
xultlin = 3
xultcol = 5
xobs    = space(1024)

// de casas {}
esvazia()

whil .t.

   if molt
      fazmolt()
      molt = .f.
   endi
   if grid
      fazgrid()
      grid = .f.
   endi
   if moln
      fazmoln()
      moln = .f.
   endi
   if mosdat
      teldados()
      mosdat = .f.
   endi
   if pnl
      fazpnl()
      pnl = .f.
   endi

   setcolor('w/n')
   @ xultlin,xultcol say ''         
   set curs on
   setcursor(1)
   tecasc = inkey(0,158) // 128 + 2 + 4 + 8 + 16 - vide inkey.ch
   teccar = chr(tecasc)
   elem   = ascan(casas,{| e | e[8] = xultlin .and. e[9] = xultcol})
   elin   = mrow()
   ecol   = mcol()

   if teccar == casas[elem][2]          // teclou numero igual ao que ja esta na casa
      loop
   endi
   if teccar $ xsimbol .and. tecasc > 48 .and. tecasc < 58  // teclou um numero
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
      else
         guarda(casas[elem][1],casas[elem][2],elem)
         if xverimode
            vericasa(teccar)
         endi
         casas[elem][2] = teccar
         if casas[elem][1] == 'f'
            casas[elem][1] = 'c'
         endi
         calcand()
         mexeu  = .t.
         mosdat = .t.
         pnl    = .t.
      endi
      loop
   endi
   if tecasc == 7 .or. tecasc == 32     // apagou a casa com del ou espao
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
      else
         xcas = casas[elem][2]
         xlin = casas[elem][4]
         xcol = casas[elem][5]
         xgru = casas[elem][6]
         xcgr = casas[elem][7]

         guarda(casas[elem][1],casas[elem][2],elem)

         if casas[elem][1] = 'f'
            casas[elem][1] = 'c'
         endi
         casas[elem][2] = ''
         casas[elem][3] = xsimbol

         for c = 1 to 9
            if c <> xcol
               tmp = ascan(casas,{| e | e[4] = xlin .and. e[5] = c})
               if at(xcas,casas[tmp][3]) = 0 .and. casas[tmp][1] <> 'f'
                  casas[tmp][3] = casas[tmp][3]+xcas
               endi
            endi
         next

         for l = 1 to 9
            if l <> xlin
               tmp = ascan(casas,{| e | e[4] = l .and. e[5] = xcol})
               if at(xcas,casas[tmp][3]) = 0 .and. casas[tmp][1] <> 'f'
                  casas[tmp][3] = casas[tmp][3]+xcas
               endi
            endi
         next

         for cg = 1 to 9
            if cg <> xcgr
               tmp = ascan(casas,{| e | e[6] = xgru .and. e[7] = cg})
               if at(xcas,casas[tmp][3]) = 0 .and. casas[tmp][1] <> 'f'
                  casas[tmp][3] = casas[tmp][3]+xcas
               endi
            endi
         next

         calcand()
         mexeu  = .t.
         mosdat = .t.
         pnl    = .t.
      endi
      loop
   endi
   if tecasc = 28
      ajuda()
      loop
   elseif tecasc = -47
      xtravafx = !xtravafx
      pnl = .t.
      loop
   elseif tecasc = -39
      if alert(diga[45],{diga[7],diga[6]}) = 2
         esvazia()
         mosdat = .t.
      endi
      loop
   elseif tecasc == 13                  // ENTER: Confirmar casa como fixa - ok
      if casas[elem][2] == ''
         alert(diga[62])
      else
         casas[elem][1] = 'f'
         calcand()
         mosdat = .t.
      endi
      loop
   elseif tecasc == 4                   // seta direita
      if xultcol < 37
         xultcol = xultcol+4
      endi
      loop
   elseif tecasc == 5                   // seta up
      if xultlin > 3
         xultlin = xultlin - 2
      endi
      loop
   elseif tecasc == 19                  // seta esquerda
      if xultcol > 5
         xultcol = xultcol - 4
      endi
      loop
   elseif tecasc == 303                 // ctrl-v - alterna verimode
      xverimode = !xverimode
      pnl       = .t.
      loop
   elseif tecasc == 24                  // seta down
      if xultlin < 19
         xultlin = xultlin+2
      endi
      loop
   elseif tecasc == 26                  // ctrl-z - desfaz jogada
      vtmp = volta()
      if vtmp <> 'e'
         calcand()
         if xverimode
            vericasa(vtmp)
         endi
         mosdat = .t.
      endi
      loop
   elseif tecasc == 27                  // ESC - sai da criao - ok
      if mexeu
         if alert(diga[36],{diga[6],diga[7]}) = 1
            salva()
            zerorecs = .f.
            valret   = .t.
         endi
      endi
      exit
   elseif tecasc == 301                 // Alt-X - Importacao por arquivo
      numerant := sudoku1->jogo1
      pegatxt()
      sele sudoku1
      seek numerant
      loop
   elseif tecasc == 1002               // abaixou o botao esquerdo do mouse
      if elin = 1
         if ecol >= 3 .and. ecol <= 31
            faltem('t')
         endi
         loop
      elseif elin >= 2 .and. elin <= 20 .and. ecol >= 43 .and. ecol <= 76  // clicou na area do memoedit
         fazmolt('nc')
         mtexto(.t.)
         molt   = .t.
         grid   = .t.
         moln   = .t.
         pnl    = .t.
         mosdat = .t.
         loop
      elseif elin >= 3 .and. elin <= 19 .and. ecol >= 4 .and. ecol <= 38  // clicou no tabuleiro
         if acx(elin,ecol)
            loop
         endi
      elseif elin = 21
         if ecol >= 4 .and. ecol <= 26  // desfaz jogada
            vtmp = volta()
            if vtmp <> 'e'
               calcand()
               if xverimode
                  vericasa(vtmp)
               endi
               mosdat = .t.
            endi
            loop
          elseif ecol >= 44 .and. ecol <= 74  // clique em ENTER: Confirmar casa como fixa
            if casas[elem][2] == ''
               alert(diga[62])
            else
               casas[elem][1] = 'f'
               calcand()
               mosdat = .t.
            endi
         endi
         loop
      elseif elin = 22               // clique em verimode
         if ecol >= 4 .and. ecol <= 25
            xverimode = !xverimode
            pnl       = .t.
         endi
         loop
      elseif elin = 23
         if ecol >= 04 .and. ecol <= 27                  // clique em Alt-F10: Reinicia o jogo
            if alert(diga[45],{diga[7],diga[6]}) = 2
               esvazia()
               mosdat = .t.
            endi
            loop
         elseif ecol >= 44 .and. ecol <= 75              // Alt-X: Importar arquivo de texto
            numerant = sudoku1->jogo1
            pegatxt()
            sele sudoku1
            seek numerant
            loop
         elseif ecol >= 44 .and. ecol <= 70
            xtravafx = !xtravafx
            pnl = .t.
            loop
         endi
      elseif elin = 24
         if ecol >= 3 .and. ecol <= 24 // clique em ESC: Sair do programa
            if mexeu
               if alert(diga[36],{diga[6],diga[7]}) = 1
                  salva()
                  zerorecs = .f.
                  valret   = .t.
               endi
            endi
            exit
         elseif ecol >= 44 .and. ecol <= 52 // clique em ENTER: confirmar casa como fixa
            ajuda()
            loop
         endi
      endi
   elseif tecasc = 1004    // abaixou o botao direito do mouse
      if elin = 1
         if ecol >= 3 .and. ecol <= 31  // clicou nos numeros faltantes
            faltem('f') 
            loop
         endi
      elseif elin >= 3 .and. elin <= 19
         if ecol >= 4 .and. ecol <= 38  // clique no tabuleiro
            if acx(elin,ecol)
               mostracan('t')
            endi
            loop
         endi
      endi
      loop
   elseif tecasc == 1006  // duplo clique esquerdo na casa, soma ate 9
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
         loop
      endi
      if acx(elin,ecol)
         if val(casas[elem][2]) < 9
            nval   = val(casas[elem][2])+1
            teccar = alltrim(str(nval))
            guarda(casas[elem][1],casas[elem][2],elem)
            if xverimode
               vericasa(teccar)
            endi
            casas[elem][2] = teccar
            if casas[elem][1] == 'f'
               casas[elem][1] = 'c'
            endi
            calcand()
            mexeu  = .t.
            mosdat = .t.
            pnl    = .t.
         else
            loop
         endi
      endi
   elseif tecasc == 1007 // duplo clique direito subtrai ate casa vazia
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
         loop
      endi
      if acx(elin,ecol)
         if val(casas[elem][2]) > 0
            nval = val(casas[elem][2]) - 1
            if nval = 0
               teccar = ' '
            else
               teccar = alltrim(str(nval))
            endi
            guarda(casas[elem][1],casas[elem][2],elem)
            if xverimode
               vericasa(teccar)
            endi
            casas[elem][2] = teccar
            if casas[elem][1] == 'f'
               casas[elem][1] = 'c'
            endi
            calcand()
            mexeu  = .t.
            mosdat = .t.
            pnl    = .t.
         else
            loop
         endi
       endi
   endi
endd
dbcommitall()
retu valret


// esvazia casas{} nos campos de dados, mantendo
// os campos de referncia no tabuleiro e na tela intactos
func esvazia()
loca i := 0

for i = 1 to 81
   casas[i][1] = 'c'
   casas[i][2] = ' '
   casas[i][3] = xsimbol
next
retu

// tratamento da entrada do nome do
// arquivo de texto para importao
func pegatxt
loca resp    := 0   // resposta ao alert de importacao via arquivo
loca corant  := ''  // para caixa que obtem nome do arquivo a importar
loca telant  := ''  // para caixa que obtem nome do arquivo a importar
loca arqtxt  := ''  // nome do arquivo a ser importado
loca arqdir  := {}
loca pos     := 0
loca cursant := 0
loca imptxt  := ''

whil resp = 0
   resp = alert(diga[66],{diga[6],diga[7],diga[67]})
endd
if resp = 1   // sim, quero mais informacao
   telant = savescreen(00,00,24,79)
   corant = setcolor('+w/b,b/w')
   @ 01,02,23,75 box chr(218)+chr(196)+chr(191)+chr(179)+chr(217)+chr(196)+chr(192)+chr(179)
   @ 02,03 clea to 22,74
   cursant = setcursor(0)
   imptxt  = memoread('hlpimp.txt')
   imptxt  = memoedit(imptxt,02,03,22,74,.f.)
   setcursor(cursant)
   // memowrit('impinfo.txt',imptxt)
   restscreen(00,00,24,79,telant)
   setcolor(corant)
elseif resp = 2                   // nao, vamos importar logo isso ai...
   telant = savescreen(05,29,13,50)
   corant = setcolor('+w/b')
   @ 05,29,13,50 box chr(218)+chr(196)+chr(191)+chr(179)+chr(217)+chr(196)+chr(192)+chr(179)
   @ 06,30 clea to 12,49
   @ 06,32 say diga[68]         
   @ 07,32 say diga[69]         
   @ 11,33 say diga[70]         
   @ 12,33 say diga[71]         
   whil .t.
      arqtxt = space(12)
      set conf on
      curant = setcursor(1)
      @ 09,34 get arqtxt pict '!!!!!!!!!!!!'        
      read
      set conf off
      setcursor(curant)
      if lastkey() = 27
         exit
      endi
      arqtxt = alltrim(arqtxt)
      if !file(arqtxt)
         alert(diga[72]+' '+arqtxt+' '+diga[76])
         loop
      else
         arqdir = directory(arqtxt)
         if arqdir[1][2] > 65536
            alert(diga[72]+' '+diga[69]+';'+diga[75])
            loop
         endi
      endi
      sele impctrl
      seek arqtxt
      if found()
         alert(diga[72]+' '+alltrim(arqtxt)+' '+diga[73]+' '+dtoc(impctrl->dtimp))
         loop
      endi
      pos    = at('.',arqtxt)
      arqext = upper(subs(arqtxt,pos+1,3))
      if arqext = 'EXE' .or. arqext = 'DBF' .or. arqext = 'BAT' .or.;
         arqext = 'ERR' .or. arqext = 'NTX' .or. arqext = 'PRG'

         alert(diga[68]+' '+diga[69]+';'+diga[74]+':.'+arqext)
         loop
      endi
      exit
   endd
   // aguarde txt2dbf(arqtxt,'c')
   restscreen(05,29,13,50,telant)
   setcolor(corant)
endi
retu