* joga
func joga()
loca tecasc := 0    // ascii da ultima tecla
loca teccar := ''   // chr da ultima tecla
loca vtmp   := ''   // valores devolvidos pela volta()

loca i        := 0
loca c        := 0
loca l        := 0
loca cg       := 0
loca numerant := 0  // para desistencia do INS: Criar novo jogo

loca xcas := ''     // guarda caracter apagado para recoloca-lo nas casas adjacentes
loca xlin := 0      // linha do tabuleiro em que o caracter foi apagado
loca xcol := 0      // coluna do tabuleiro em que o caracter foi apagado
loca xgru := 0      // grupo no tabuleiro em que o caracter foi apagado
loca xcgr := 0      // casa do tabuleiro em que o caracter foi apagado
loca tmp  := 0      // auxiliar para redistribuicao de caracteres apagados
loca nval := 0      // auxiliar para somar ou subtrair casas com o mouse

loca mexeu := .f.   // para salvar - ou nao - o jogo na saida

loca molt     := .t.                    // moldura do tabuleiro
loca grid     := .t.                    // grid do tabuleiro
loca moln     := .t.                    // molduta das notas
loca pnl      := .t.                    // painel
loca mosdat   := .t.                    // flag - (re)carrega e (re)mostra os dados
loca fazcarga := .t.                    // carrega a ram dados dos dbfs

loca elin := 0      // para a posio do mouse em mrow()
loca ecol := 0      // para a posio do mouse em mcol()

sele rollback
zap
dbcommitall()

whil .t.

   if molt
      fazmolt()
      molt = .f.
   endi
   if grid
      fazgrid()
      grid = .f.
   endi
   if moln
      fazmoln()
      moln = .f.
   endi
   if fazcarga
      carrega()
      fazcarga = .f.
   endi
   if mosdat
      teldados()
      mosdat = .f.
   endi
   if pnl
      fazpnl()
      pnl = .f.
   endi

   setcolor('w/n')
   @ xultlin,xultcol say ''         
   setcursor(1)
   tecasc = inkey(0,158) // 128 + 2 + 4 + 8 + 16 - vide inkey.ch
   teccar = chr(tecasc)
   elem   = ascan(casas,{| e | e[8] = xultlin .and. e[9] = xultcol})
   elin   = mrow()
   ecol   = mcol()

   if teccar == casas[elem][2] // teclou numero igual ao que ja esta na casa
      loop
   endi
   if teccar $ xsimbol .and. tecasc > 48 .and. tecasc < 58 // teclou um numero
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
      else
         guarda(casas[elem][1],casas[elem][2],elem)
         if xverimode
            vericasa(teccar)
         endi
         casas[elem][2] = teccar
         if casas[elem][1] == 'f'
            casas[elem][1] = 'c'
         endi
         calcand()
         mexeu  = .t.
         mosdat = .t.
         pnl    = .t.
      endi
      loop
   endi
   if tecasc == 7 .or. tecasc == 32  // apagou a casa com del ou espao
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
      else
         xcas = casas[elem][2]
         xlin = casas[elem][4]
         xcol = casas[elem][5]
         xgru = casas[elem][6]
         xcgr = casas[elem][7]

         guarda(casas[elem][1],casas[elem][2],elem)

         if casas[elem][1] = 'f'
            casas[elem][1] = 'c'
         endi
         casas[elem][2] = ''
         casas[elem][3] = xsimbol

         for c = 1 to 9
            if c <> xcol
               tmp = ascan(casas,{| e | e[4] = xlin .and. e[5] = c})
               if at(xcas,casas[tmp][3]) = 0 .and. casas[tmp][1] <> 'f'
                  casas[tmp][3] = casas[tmp][3]+xcas
               endi
            endi
         next

         for l = 1 to 9
            if l <> xlin
               tmp = ascan(casas,{| e | e[4] = l .and. e[5] = xcol})
               if at(xcas,casas[tmp][3]) = 0 .and. casas[tmp][1] <> 'f'
                  casas[tmp][3] = casas[tmp][3]+xcas
               endi
            endi
         next

         for cg = 1 to 9
            if cg <> xcgr
               tmp = ascan(casas,{| e | e[6] = xgru .and. e[7] = cg})
               if at(xcas,casas[tmp][3]) = 0 .and. casas[tmp][1] <> 'f'
                  casas[tmp][3] = casas[tmp][3]+xcas
               endi
            endi
         next

         calcand()
         mexeu  = .t.
         mosdat = .t.
         pnl    = .t.
      endi
      loop
   endi
   if tecasc == 28 // ajuda
      ajuda()
      loop
   elseif tecasc = -47
      xtravafx = !xtravafx
      pnl = .t.
      loop
   elseif tecasc == - 39                // Alt-F10 - reset 
      if alert(diga[45],{diga[7],diga[6]}) = 2
         for i = 1 to 81
            dbcpo1  = 'sudoku2->o'+strzero(i,2)
            dbcpo2  = 'sudoku1->s'+strzero(i,2)
            dbcpo3  = 'sudoku1->f'+strzero(i,2)
            dbcpo4  = 'sudoku1->c'+strzero(i,2)
            &dbcpo2 = &dbcpo1
            if &dbcpo1 == ' '
               &dbcpo3 = 'c'
               &dbcpo4 = xsimbol
            else
               &dbcpo3 = 'f'
               &dbcpo4 = ' '
            endi
         next
         carrega()
         calcand()
         mexeu  = .f.
         molt   = .t.
         grid   = .t.
         moln   = .t.
         pnl    = .t.
         mosdat = .t.
         loop
      endi
      loop
   elseif tecasc == 18                  // PgUp
      if temac
         if mexeu
            if alert(diga[23],{diga[6],diga[7]}) < 2
               salva()
            endi
         endi
         sele sudoku1
         skip - 1
         xnumero  = sudoku1->jogo1
         fazcarga = .t.
         mosdat   = .t.
         pnl      = .t.
      endi
      loop
   elseif tecasc == 3                   // PgDn
      if temab
         if mexeu
            if alert(diga[23],{diga[6],diga[7]}) < 2
               salva()
            endi
         endi
         sele sudoku1
         skip
         xnumero  = sudoku1->jogo1
         fazcarga = .t.
         mosdat   = .t.
         pnl      = .t.
      endi
      loop
   elseif tecasc == 22                  // Ins
      if mexeu
         if alert(diga[23],{diga[6],diga[7]}) < 2
            salva()
         endi
      endi
      numerant = xnumero
      if .not. cria()
         sele sudoku1
         seek numerant
      endi
      molt     = .t.
      grid     = .t.
      moln     = .t.
      pnl      = .t.
      fazcarga = .t.
      mosdat   = .t.
      loop
   elseif tecasc == 4                   // seta direita
      if xultcol < 37
         xultcol = xultcol+4
      endi
      loop
   elseif tecasc == 5                   // seta up
      if xultlin > 3
         xultlin = xultlin - 2
      endi
      loop
   elseif tecasc == 19                  // seta esquerda
      if xultcol > 5
         xultcol = xultcol - 4
      endi
      loop
   elseif tecasc == 303                 // ctrl-v - alterna verimode
      xverimode = !xverimode
      pnl       = .t.
      loop
   elseif tecasc == 24                  // seta down
      if xultlin < 19
         xultlin = xultlin+2
      endi
      loop
   elseif tecasc == 26                  // ctrl-z - desfaz jogada
      vtmp = volta()
      if vtmp <> 'e'
         calcand()
         if xverimode
            vericasa(vtmp)
         endi
         mosdat = .t.
      endi
      loop
   elseif tecasc == 27                  // ESC - sai do jogo
      set curs off
      if mexeu
         if alert(diga[36],{diga[6],diga[7]}) < 2
            salva()
         endi
      endi
      exit
   elseif tecasc == 1002                // abaixou o botao esquerdo do mouse
      if elin = 1
         if ecol >= 3 .and. ecol <= 31
            faltem('t')
         endi
         loop
      elseif elin >= 2 .and. elin <= 20 .and. ecol >= 43 .and. ecol <= 76 // clicou na area do memoedit
         fazmolt('nj')
         mtexto(.t.)
         molt   = .t.
         grid   = .t.
         moln   = .t.
         pnl    = .t.
         mosdat = .t.
         mexeu  = .t.
      elseif elin >= 3 .and. elin <= 19 .and. ecol >= 4 .and. ecol <= 38 // clicou numa casa do tabuleiro
         if acx(elin,ecol)
            loop
         endi
      elseif elin == 21
         if ecol >= 4 .and. ecol <= 26  // clique em Ctrl-Z: Desfazer jogada
            vtmp = volta()
            if vtmp <> 'e'
               calcand()
               if xverimode
                  vericasa(vtmp)
               endi
               mosdat = .t.
            endi
            loop
         elseif ecol >= 44 .and. ecol <= 56                 // PgUp
            if temac
               if mexeu
                  if alert(diga[23],{diga[6],diga[7]}) < 2
                     salva()
                  endi
               endi
               sele sudoku1
               skip - 1
               xnumero  = sudoku1->jogo1
               fazcarga = .t.
               mosdat   = .t.
               pnl      = .t.
            endi
            loop
         elseif ecol >= 62 .and. ecol <= 75                 // PgDn
            if temab
               if mexeu
                  if alert(diga[23],{diga[6],diga[7]}) < 2
                     salva()
                  endi
               endi
               sele sudoku1
               skip
               xnumero  = sudoku1->jogo1
               fazcarga = .t.
               mosdat   = .t.
               pnl      = .t.
            endi
            loop
         endi
      elseif elin == 22
         if ecol >= 4 .and. ecol <= 25  // clique em verimode
            xverimode = !xverimode
            pnl       = .t.
            loop
         elseif ecol >= 44 .and. ecol <= 63 // INS: Criar novo jogo
            if mexeu
               if alert(diga[23],{diga[6],diga[7]}) < 2
                  salva()
               endi
            endi
            numerant = xnumero
            if .not. cria()
               sele sudoku1
               seek numerant
            endi
            molt     = .t.
            grid     = .t.
            moln     = .t.
            pnl      = .t.
            fazcarga = .t.
            mosdat   = .t.
            loop
         endi
      elseif elin == 23
         if ecol >= 4 .and. ecol <= 27  // clique em Alt-F10: Reinicia o jogo
            if alert(diga[45],{diga[7],diga[6]}) = 2
               for i = 1 to 81
                  dbcpo1  = 'sudoku2->o'+strzero(i,2)
                  dbcpo2  = 'sudoku1->s'+strzero(i,2)
                  dbcpo3  = 'sudoku1->f'+strzero(i,2)
                  dbcpo4  = 'sudoku1->c'+strzero(i,2)
                  &dbcpo2 = &dbcpo1
                  if &dbcpo1 == ' '
                     &dbcpo3 = 'c'
                     &dbcpo4 = xsimbol
                  else
                     &dbcpo3 = 'f'
                     &dbcpo4 = ' '
                  endi
               next
               carrega()
               calcand()
               mexeu  = .f.
               molt   = .t.
               grid   = .t.
               moln   = .t.
               pnl    = .t.
               mosdat = .t.
               loop
            endi
         elseif ecol >= 44 .and. ecol <= 70
            xtravafx = !xtravafx
            pnl = .t.
            loop
         endi
      elseif elin = 24
         if ecol >= 4 .and. ecol <= 21  // clique em ESC: Sair do programa
            set curs off
            if mexeu
               if alert(diga[36],{diga[6],diga[7]}) < 2
                  salva()
               endi
            endi
            exit
         elseif ecol >= 44 .and. ecol <= 51  //clique em F1: Ajuda
            ajuda()
            loop
         endi
      endi
      loop
   elseif tecasc == 1004 // abaixou o botao direito do mouse
      if elin = 1
         if ecol >= 3 .and. ecol <= 31 // clicou nos numeros faltantes
            faltem('f')
            loop
         endi
      elseif elin >= 3 .and. elin <= 19
         if ecol >= 4 .and. ecol <= 38  // clique no tabuleiro
            if acx(elin,ecol)
               mostracan('t')
            endi
            loop
         endi
      endi
      loop
   elseif tecasc == 1006  // duplo clique esquerdo na casa, soma ate 9
      if xtravafx .and. casas[elem][1] == 'f'
         alert(diga[61])
         loop
      endi
      if acx(elin,ecol)
         if val(casas[elem][2]) < 9
            nval   = val(casas[elem][2])+1
            teccar = alltrim(str(nval))
            guarda(casas[elem][1],casas[elem][2],elem)
            if xverimode
               vericasa(teccar)
            endi
            casas[elem][2] = teccar
            if casas[elem][1] == 'f'
               casas[elem][1] = 'c'
            endi
            calcand()
            mexeu  = .t.
            mosdat = .t.
            pnl    = .t.
         else
            loop
         endi
      endi
   elseif tecasc == 1007 // duplo clique direito subtrai ate casa vazia
      if acx(elin,ecol)
         if xtravafx .and. casas[elem][1] == 'f'
            alert(diga[61])
            loop
         endi
         if val(casas[elem][2]) > 0
            nval = val(casas[elem][2]) - 1
            if nval = 0
               teccar = ' '
            else
               teccar = alltrim(str(nval))
            endi
            guarda(casas[elem][1],casas[elem][2],elem)
            if xverimode
               vericasa(teccar)
            endi
            casas[elem][2] = teccar
            if casas[elem][1] == 'f'
               casas[elem][1] = 'c'
            endi
            calcand()
            mexeu  = .t.
            mosdat = .t.
            pnl    = .t.
         else
            loop
         endi
      endi
   endi
endd
dbcommitall()
retu

