* cria um arquivo texto contendo jogos tanto para a carga do programa quanto para exemplo
func criajogo()     // carrega dbfs com os primeiros jogos
loca nhandle := 0
loca linha   := ''
loca fim     := chr(13)+chr(10)

nhandle = fcreate('sudo0001.jxt',0)

// primeiro bloco: casas // alinhamento para faciliar a conferencia contra o original
linha = '....5.48.'
linha = linha+'6.92.....'
linha = linha+'2...4..1.'
linha = linha+'....8..9.'
linha = linha+'4.7.2.8.5'
linha = linha+'.1..6....'
linha = linha+'.9..3...6'
linha = linha+'.....43.8'
linha = linha+'.21.7....'

// virgula necessaria
linha = linha+','

// segundo bloco: comentarios
linha = linha+'Nivel facil. Esse e o primeiro jogo do programa, como demonstracao. Original da revista Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 23, pag. 8'+fim

fseek(nhandle,0,1)
fwrite(nhandle,linha)

// numa unica linha
linha = ''
linha = '...8..3....256.....1...7..697....6...4.....5...3....283..4...6.....298....6..1...,Nivel medio. Original na revista Sudoku, ed. 93, jogo 79, pag. 22, da Ed. Coquetel, ISSN 1808-6837 - Maio de 2013'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// linha unica termina em vírgula
linha = ''
linha = '1..457.....49....27..2..1..5...3..4.61...853.....9....8.7..4....5......32.35....1,http://forum.enjoysudoku.com/sudoku-solver-software-with-free-source-code-t32635.html'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// em duas linhas. virgula necessaria
linha = ''
linha = '..64.51...........8.29.15.41.7.9.2.6...6.4...3.5.7.4.84.92.37.1...........15.96..'
linha = linha+',Facil. Original da revista Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 22, pag. 8'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// numa unica linha
linha = ''
linha = '..6.........1..5..4....5.6..1..3.2.....416.....5.8..9..8.7....1..2..4.........3..,Dificil. Original na pag. 8, no. 22 da Coquetel Sudoku Dificil n. 92 - ISSN 1808-9674 - 06-2013'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// numa unica linha
linha = ''
linha = '..7..51...4..3..6.1..9..3.5..5.....6.7.....4.9.....7..3.8..1..9.1..4..3...47..2..,Facil. Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 25, pag. 8'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// apenas as casas. nesse caso nao é necessaria virgula
linha = ''
linha = '.....3.5.8.35..267.5.81..4.1.....87...8.6.3...62.....1.8..27.1...7..85.9.3.9.....'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// com erro: menos de 81 casas
linha = ''
linha = '..7.51...4..3..6.1..9..3.5..5.....6.7.....4.9.....7..3.8..1..9.1..4..3...47..2..,Facil. Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 25, pag. 8'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// com erro: mais de 81 casas
linha = ''
linha = '1..7.51...4..3..6.1..9..3.5..5.....6.7.....4.9.....7..3.8..1..9.1..4..3...47..2..,Facil. Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 25, pag. 8'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// com erro: simbolo inadequado no meio
linha = ''
linha = '..7..51...4..3..6.1..9..3.5..5.....6.7.....4.9.....7..3.8..1..9.1..4..3...47..A..,Facil. Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 25, pag. 8'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// com erro: com comentario mas sem virgula entre as casas e o comentario
linha = ''
linha = '..7.51...4..3..6.1..9..3.5..5.....6.7.....4.9.....7..3.8..1..9.1..4..3...47..2..Facil. Coquetel Sudoku Numerox no. 122 - 10/2015 - jogo 25, pag. 8'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)

// sem erro: com comentario
linha = ''
linha = '....2.....51...29..7.5.4.3...8...1..1...3...2..6...9...8.2.6.7..43...68.....5....,Medio. Coquetel Sudoku Medio no. 105 Jogo 27, Pag. 9 - ISSN 1808-966 - 09/2013'+fim
fseek(nhandle,0,1)
fwrite(nhandle,linha)
fclose(nhandle)

txt2dbf('sudo0001.jxt','p')

// e pegando uma carona na criacao dos arquivos texto...

// ajuda para a importacao

nhandle = fcreate('hlpimp.txt',0)
linha   = ''
linha   = 'Para criacao de arquivo de texto contendo jogos para importacao por'+fim
linha   = linha+'este programa, veja os exemplos na mesma pasta em que o jogo esta'+fim
linha   = linha+'instalado. O arquivo de exemplo chama-se "sudo0001.jxt".'+fim+fim
linha   = linha+'Como esse arquivo ja foi importado, o programa gravou um outro'+fim
linha   = linha+'arquivo nessa mesma pasta com o resultado da importacao. Esse arquivo'+fim
linha   = linha+'tem o mesmo nome do arquivo que contem os jogos, mas com a extensao'+fim
linha   = linha+'"ERR". Chama-se, portanto, "sudo0001.err".'+fim+fim
linha   = linha+'O programa nao importa mais de uma vez um arquivo de texto. Caso tenha'+fim
linha   = linha+'erros, depois de corrigi-los e de deletar as linhas que foram'+fim
linha   = linha+'importadas com sucesso, renomeio-o, sempre no formato MS-DOS (8.3)'+fim+fim+fim+fim
linha   = linha+'Tecle ESC para retornar a tela de criacao de jogos.'+fim

fseek(nhandle,0,1)
fwrite(nhandle,linha)
fclose(nhandle)

/*

nhandle = fcreate('hlpman.txt',0)
linha   = ''
linha   = 'Para criacao de arquivo de texto contendo jogos para importacao por'+fim
linha   = linha+'este programa, veja os exemplos na mesma pasta em que o jogo esta'+fim
linha   = linha+'instalado. O arquivo de exemplo chama-se "sudo0001.jxt".'+fim+fim
linha   = linha+'Como esse arquivo ja foi importado, o programa gravou um outro'+fim
linha   = linha+'arquivo nessa mesma pasta com o resultado da importacao. Esse arquivo'+fim
linha   = linha+'tem o mesmo nome do arquivo que contem os jogos, mas com a extensao'+fim
linha   = linha+'"ERR". Chama-se, portanto, "sudo0001.err".'+fim+fim
linha   = linha+'O programa nao importa mais de uma vez um arquivo de texto. Caso tenha'+fim
linha   = linha+'erros, depois de corrigi-los e de deletar as linhas que foram'+fim
linha   = linha+'importadas com sucesso, renomeio-o, sempre no formato MS-DOS (8.3)'+fim+fim+fim+fim
linha   = linha+'Tecle ESC para retornar a tela de criacao de jogos.'+fim

fseek(nhandle,0,1)
fwrite(nhandle,linha)
fclose(nhandle)
*/


retu
