// verifica se um numero recm digitado ja esta em sua linha, coluna ou grupo
// se estiver "manda um recado" para a funcao teldados, para alterar as cores de exibicao
// do numero digitado e dos coincidentes. mas o aceita.
func vericasa(digitado)

loca l       := 0   // se estiver, muda a flag casas[elem][1] mas apenas para apresentacao
loca c       := 0   // na tela. A funcao teldados() retorna a flag ao que era
loca cg      := 0
loca xlin    := 0
loca xcol    := 0
loca xgru    := 0
loca velem   := {}
loca val_ret := .f.

elem := ascan(casas,{| e | e[8] = xultlin .and. e[9] = xultcol})
xlin := casas[elem][4]
xcol := casas[elem][5]
xgru := casas[elem][6]
xcgr := casas[elem][7]

for c = 1 to 9     // procura nas colunas de uma linha
   if c <> xcol
      velem = ascan(casas,{| e | e[4] = xlin .and. e[5] = c})
      if casas[velem][2] == digitado
         if casas[velem][1] == 'f'
            casas[velem][1] = 'g'
         elseif casas[velem][1] == 'c'
            casas[velem][1] = 'd'
         endi
         val_ret = .t.
      endi
   endi
next

for l = 1 to 9     // procura nas linhas de uma coluna
   if l <> xlin
      velem = ascan(casas,{| e | e[5] = xcol .and. e[4] = l})
      if casas[velem][2] == digitado
         if casas[velem][1] == 'f'
            casas[velem][1] = 'g'
         elseif casas[velem][1] == 'c'
            casas[velem][1] = 'd'
         endi
         val_ret = .t.
      endi
   endi
next

for cg = 1 to 9    // procura nas casas de um grupo
   if cg <> xcgr
      velem = ascan(casas,{| e | e[6] = xgru .and. e[7] = cg})
      if casas[velem][2] == digitado
         if casas[velem][1] == 'f'
            casas[velem][1] = 'g'
         elseif casas[velem][1] == 'c'
            casas[velem][1] = 'd'
         endi
         val_ret = .t.
      endi
   endi
next

if val_ret
   if casas[elem][1] = 'f'
      casas[elem][1] = 'g'
   elseif casas[elem][1] = 'c'
      casas[elem][1] = 'd'
   endi
endi
retu val_ret



// calcula os candidatos de todas as casas, eliminando as impossibilidades
// faz isso a cada digitacao de novo numero ou apagamento de casa preenchida
func calcand()
loca i      := 0
loca l      := 0
loca c      := 0
loca g      := 0
loca cg     := 0
loca celem  := 0
loca tmp    := ''
loca cdbcpo := ''

for l = 1 to 9     // linhas
   tmp = ''
   for c = 1 to 9
      celem = ascan(casas,{| e | e[4] = l .and. e[5] = c})
      if len(alltrim(casas[celem][2])) = 1
         tmp = tmp+alltrim(casas[celem][2])
      endi
   next
   if len(tmp) > 0
      for c = 1 to 9
         celem = ascan(casas,{| e | e[4] = l .and. e[5] = c})
         casas[celem][3] = sort(tira(tmp,casas[celem][3]))
      next
   endi
next

for c = 1 to 9     // colunas
   tmp = ''
   for l = 1 to 9
      celem = ascan(casas,{| e | e[5] = c .and. e[4] = l})
      if len(alltrim(casas[celem][2])) = 1
         tmp = tmp+(alltrim(casas[celem][2]))
      endi
   next
   if len(tmp) > 0
      for l = 1 to 9
         celem = ascan(casas,{| e | e[5] = c .and. e[4] = l})
         casas[celem][3] = sort(tira(tmp,casas[celem][3]))
      next
   endi
next

for g = 1 to 9     // grupos
   tmp = ''
   for cg = 1 to 9
      celem = ascan(casas,{| e | e[6] = g .and. e[7] = cg})
      if len(alltrim(casas[celem][2])) = 1
         tmp = tmp+(alltrim(casas[celem][2]))
      endi
   next
   if len(tmp) > 0
      for cg = 1 to 9
         celem = ascan(casas,{| e | e[6] = g .and. e[7] = cg})
         casas[celem][3] = sort(tira(tmp,casas[celem][3]))
      next
   endi
next

tiradois()

for i = 1 to 81    // atualiza sudoku1->cnn
   cdbcpo  = 'sudoku1->c'+strzero(i,2,0)
   &cdbcpo = casas[i][3]
next

dbcommitall()
retu

func tiradois()
loca l := 0
loca c := 0
loca i := 0
loca j := 0
loca tmp1 := 0
loca tmp2 := 0
loca tmp3 := 0

for l = 1 to 9
   for c = 1 to 9
      for i = 1 to 9
         if i > c
            tmp1 = ascan(casas,{|e| e[4] = l .and. e[5] = c})
            if len(casas[tmp1][3]) == 2
               tmp2 = ascan(casas,{|e| e[4] = l .and. e[5] = i})
               if casas[tmp1][3] = casas[tmp2][3]
                  for j = 1 to 9
                     if j <> tmp1 .and. j <> tmp2
                        tmp3 = ascan(casas,{|e| e[4] = l .and. e[5] = j})
                        casas[tmp3][3] = sort(tira(casas[tmp2][3],casas[tmp3][3]))
                     endi
                  next
               endi
            endi
         endi
      next
   next
next

for c = 1 to 9
   for l = 1 to 9
      for i = 1 to 9
         if i > l
            tmp1 = ascan(casas,{|e| e[5] = c .and. e[4] = l})
            if len(casas[tmp1][3]) == 2
               tmp2 = ascan(casas,{|e| e[5] = c .and. e[4] = i})
               if casas[tmp1][3] = casas[tmp2][3]
                  for j = 1 to 9
                     if j <> tmp1 .and. j <> tmp2
                        tmp3 = ascan(casas,{|e| e[5] = c .and. e[4] = j})
                        casas[tmp3][3] = sort(tira(casas[tmp2][3],casas[tmp3][3]))
                     endi
                  next
               endi
            endi
         endi
      next
   next
next

for g = 1 to 9
   for cg = 1 to 9
      for i = 1 to 9
         if i > cg
            tmp1 = ascan(casas,{|e| e[6] = g .and. e[7] = cg})
            if len(casas[tmp1][3]) == 2
               tmp2 = ascan(casas,{|e| e[6] = g .and. e[7] = i})
               if casas[tmp1][3] = casas[tmp2][3]
                  for j = 1 to 9
                     if j <> tmp1 .and. j <> tmp2
                        tmp3 = ascan(casas,{|e| e[6] = g .and. e[7] = j})
                        casas[tmp3][3] = sort(tira(casas[tmp2][3],casas[tmp3][3]))
                     endi
                  next
               endi
            endi
         endi
      next
   next
next
retu

* funciona com calcand e tiradois, acima
func tira(parte,todo)   // ex. tira('71','231457') = '2345' / tira('123','456') = '456' / tira('123','1') = '1'
loca i       := 0       //     tira('2',123456789) = '13456789)
loca pt      := ''
loca val_ret := todo

for i = 1 to len(todo)
   if at(subs(todo,i,1),parte) = 0
      pt = pt+subs(todo,i,1)
   endi
next
if len(pt) > 0
   val_ret = alltrim(pt)
endi
retu val_ret


* mostra os candidatos de determinada casa
func mostracan(origem)
loca i       := 0
loca casatu  := 0
loca msg     := ''
loca elem    := 0
loca temp1   := ''
loca temp2   := ''
loca letras  := 'ABCDEFGHI'
loca tammsg  := 0
loca telant  := ''
loca corant  := ''
loca quadant := ''
loca cd      := 0
loca mm      := ''
loca xulin   := xultlin
loca xucol   := xultcol

elem = ascan(casas,{| e | e[8] = xultlin .and. e[9] = xultcol})

if len(alltrim(casas[elem][2])) = 1
   corant = setcolor('+w/b')
   mm     = ' '+alltrim(casas[elem][2])+' '
else
   corant = setcolor('+w/r')
   mm     = ' ? '
endi

temp1 = alltrim(casas[elem][3])

for i = 1 to len(temp1)
   temp2 = temp2+subs(temp1,i,1)+','
next
if subs(temp2,len(temp2),1) = ','
   temp2 = subs(temp2,1,len(temp2) - 1)
endi

if casas[elem][1] = 'f'
   msg = diga[61]  // casa fixa
else
   msg = diga[44]+' '+subs(letras,casas[elem][4],1)+str(casas[elem][5],1,0)+': '+temp2
endi

tammsg  = len(msg)
cd      = 41+tammsg+1
telant  = savescreen(xultlin - 1,41,xultlin+1,cd)
quadant = savescreen(xultlin,xultcol - 1,xultlin,xultcol+1)

@ xultlin - 1,41,xultlin+1,cd box chr(218)+chr(196)+chr(191)+chr(179)+chr(217)+chr(196)+chr(192)+chr(179)
@ xultlin,42          say msg         
@ xultlin,xultcol - 1 say mm          

if origem = 'p'
   inkey(0,130)
elseif origem = 't'
   inkey(0,16)
endi

setcolor(corant)
restscreen(xultlin - 1,41,xultlin+1,cd,telant)
restscreen(xultlin,xultcol - 1,xultlin,xultcol+1,quadant)
xultlin = xulin
xultcol = xucol
retu


* para cliques no tabuleiro que caiam em linhas e no no meio das casas
func acx(acxlin,acxcol) // ajusta posio vlida para o mouse no tabuleiro
loca valret := .t.

if acxlin > 2 .and. acxlin < 20 .and. acxcol > 3 .and. acxcol < 39
   if (acxlin % 2 = 0) = .f.
      xultlin = acxlin
      if acxcol >= 04 .and. acxcol <= 06
         xultcol = 05
      elseif acxcol >= 08 .and. acxcol <= 10
         xultcol = 09
      elseif acxcol >= 12 .and. acxcol <= 14
         xultcol = 13
      elseif acxcol >= 16 .and. acxcol <= 18
         xultcol = 17
      elseif acxcol >= 20 .and. acxcol <= 22
         xultcol = 21
      elseif acxcol >= 24 .and. acxcol <= 26
         xultcol = 25
      elseif acxcol >= 28 .and. acxcol <= 30
         xultcol = 29
      elseif acxcol >= 32 .and. acxcol <= 34
         xultcol = 33
      elseif acxcol >= 36 .and. acxcol <= 38
         xultcol = 37
      else
         valret = .f.
      endi
   else
      valret = .f.
   endi
else
   valret = .f.
endi
retu valret


* para mostrar os candidatos em ordem
func sort(cadeia)
loca i         := 0
loca baguncado := {}
loca tmp       := {}
loca sorteado  := ''
loca xnum      := .f.

if valtype(cadeia) = 'N'
   ccadeia = alltrim(str(cadeia))
   xnum    = .t.
else
   ccadeia = cadeia
endi
if len(ccadeia) = 0
   if xnum
      sorteado = 0
   else
      sorteado = ''
   endi
else
   for i = 1 to len(ccadeia)
      aadd(baguncado,subs(ccadeia,i,1))
   next
   tmp = asort(baguncado)
   for i = 1 to len(tmp)
      if at(tmp[i],sorteado) = 0
         sorteado = sorteado+tmp[i]
      endi
   next
   sorteado = alltrim(sorteado)
   if xnum
      sorteado = val(sorteado)
   endi
endi
retu sorteado


* para se precisar voltar jogadas com ctrl-z
func guarda(rflg,rtec,rlem)
loca i := 0
loca j := 0

sele rollback
appe blan
rollback->rulin = xultlin
rollback->rucol = xultcol
rollback->rflag = rflg
rollback->rsimb = rtec
rollback->relem = rlem
dbcommitall()
retu


* para voltar jogadas com ctrl-z
func volta()
loca valret := ''
loca vflag  := ''
loca vsimb  := ''
loca velem  := 0

sele rollback
goto bottom
if eof()
   alert(diga[48])
   valret = 'e'
else
   xultlin = rollback->rulin
   xultcol = rollback->rucol
   vflag   = rollback->rflag
   vsimb   = rollback->rsimb
   velem   = rollback->relem
   casas[velem][1] = vflag
   casas[velem][2] = vsimb
   valret = vsimb
   dele
   pack
   dbcommitall()
endi
retu valret

